#pragma once


namespace Simulator {

	using namespace System;

	public ref class MemorySystem 
	{
	public:
		MemorySystem(String^ romPath, unsigned long loadAddress);
		unsigned char Load(unsigned long address);
		unsigned char Peek(unsigned long address);
		String^ LCDText() { return m_lcdText->Substring(0,24) + "\r\n" + 
								   m_lcdText->Substring(24,24); }
		void ClearLCD() { m_lcdText = "                                                "; }

		void Store(unsigned long address, unsigned char value);

	protected:
		~MemorySystem() {}

		static const int s_romSize = 16 * 1024;

		static const int s_ramSize = 0x210000;
		array<unsigned char>^ m_ram;

		String^ m_lcdText;
		int m_lcdPos;
	};
}

