#pragma once

using namespace System::Windows::Forms;
using namespace System::Collections::Generic;

namespace Simulator {

	ref class MachineState;

	using namespace System;

	public value class MicroInstructionData
	{
	public:
		property unsigned char AddressCarry;
		property unsigned char Carry;
		property unsigned char Negative;
		property unsigned char Zero;
		property unsigned char Overflow;
	};

	public ref class MicroDisassembly 
	{
	public:
		MicroDisassembly(MachineState^ machineState);

		void FillDisassemblyTextBox(TextBox^ textBox);
		void FillDisassemblyListView(ListView^ listView, Dictionary<unsigned long, List<unsigned long>^>^ microSourceBreakpoints);

	protected:
		~MicroDisassembly() {}
		String^ ConditionString(unsigned char bits, String^ name, bool isActiveLow);
		String^ DestinationString(unsigned long microOp);
		String^ LeftALUString(unsigned long microOp);
		String^ RightALUString(unsigned long microOp);
		String^ AddressByteName(unsigned long rightOp);
		String^ MicroOpDescription(unsigned long microOp);
		Dictionary<unsigned long, MicroInstructionData> m_microInstructionLookup;
		MachineState^ m_machineState;
	};
}

